---
title: WebGL2RenderingContext.copyBufferSubData()
slug: Web/API/WebGL2RenderingContext/copyBufferSubData
tags:
  - API
  - Method
  - Reference
  - WebGL
  - WebGL2
---
<div>{{APIRef("WebGL")}}</div>

<p>The <strong><code>WebGL2RenderingContext.copyBufferSubData()</code></strong> method of the <a href="/en-US/docs/Web/API/WebGL_API">WebGL 2 API</a> copies part of the data of a buffer to another buffer.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">void <var>gl</var>.copyBufferSubData(<var>readTarget</var>, <var>writeTarget</var>, <var>readOffset</var>, <var>writeOffset</var>, <var>size</var>);</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code>readTarget<br>
 writeTarget</code></dt>
 <dd>A {{domxref("GLenum")}} specifying the binding point (target) from whose data store should be read or written. Possible values:
 <ul>
  <li><code>gl.ARRAY_BUFFER</code>: Buffer containing vertex attributes, such as vertex coordinates, texture coordinate data, or vertex color data.</li>
  <li><code>gl.ELEMENT_ARRAY_BUFFER</code>: Buffer used for element indices.</li>
  <li><code>gl.COPY_READ_BUFFER</code>: Buffer for copying from one buffer object to another (provided specifically for copy operations).</li>
  <li><code>gl.COPY_WRITE_BUFFER</code>: Buffer for copying from one buffer object to another (provided specifically for copy operations).</li>
  <li><code>gl.TRANSFORM_FEEDBACK_BUFFER</code>: Buffer for transform feedback operations.</li>
  <li><code>gl.UNIFORM_BUFFER</code>: Buffer used for storing uniform blocks.</li>
  <li><code>gl.PIXEL_PACK_BUFFER</code>: Buffer used for pixel transfer operations.</li>
  <li><code>gl.PIXEL_UNPACK_BUFFER</code>: Buffer used for pixel transfer operations.</li>
 </ul>
 </dd>
 <dt><code>readOffset<br>
 writeOffset</code></dt>
 <dd>A {{domxref("GLintptr")}} specifying the byte offset from which to start reading from or writing to the buffer.</dd>
 <dt><code>size</code></dt>
 <dd>A {{domxref("GLsizei")}} in bytes specifying the size of the data to be copied from <code>readTarget</code> to <code>writeTarget</code>.</dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>None.</p>

<h2 id="Examples">Examples</h2>

<pre class="brush: js">var srcBuffer = gl.createBuffer();
var dstBuffer = gl.createBuffer();

var data = new Float32Array(vertices);
var length = vertices.length * 4;

gl.bindBuffer(gl.ARRAY_BUFFER, srcBuffer);
gl.bufferData(gl.ARRAY_BUFFER, data, gl.STATIC_DRAW);
gl.bindBuffer(gl.COPY_READ_BUFFER, srcBuffer);

gl.bindBuffer(gl.ARRAY_BUFFER, dstBuffer);
gl.bufferData(gl.ARRAY_BUFFER, new Float32Array(length), gl.STATIC_DRAW);

gl.copyBufferSubData(gl.COPY_READ_BUFFER, gl.ARRAY_BUFFER, 0, 0, length);
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('WebGL2', "#3.7.3", "copyBufferSubData")}}</td>
   <td>{{Spec2('WebGL2')}}</td>
   <td>Initial definition for WebGL.</td>
  </tr>
  <tr>
   <td>{{SpecName('OpenGL ES 3.0', "glCopyBufferSubData.xhtml", "glCopyBufferSubData")}}</td>
   <td>{{Spec2('OpenGL ES 3.0')}}</td>
   <td>Man page of the (similar) OpenGL API.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p class="hidden">The compatibility table in this page is generated from structured data. If you'd like to contribute to the data, please check out <a href="https://github.com/mdn/browser-compat-data">https://github.com/mdn/browser-compat-data</a> and send us a pull request.</p>

<p>{{Compat("api.WebGL2RenderingContext.copyBufferSubData")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{domxref("WebGLRenderingContext.bufferData()")}}</li>
 <li>{{domxref("WebGLRenderingContext.bufferSubData()")}}</li>
 <li>{{domxref("WebGLRenderingContext.getBufferParameter()")}}</li>
 <li>{{domxref("WebGL2RenderingContext.getBufferSubData()")}}</li>
</ul>
